Last Comment Bug 722139 - Turn on harfbuzz shaper by default for Hebrew on all platforms
: Turn on harfbuzz shaper by default for Hebrew on all platforms
Status: RESOLVED FIXED
:
Product: Core
Classification: Components
Component: Layout: Text (show other bugs)
: unspecified
: All All
: -- normal (vote)
: mozilla13
Assigned To: Jonathan Kew (:jfkthame)
:
Mentors:
Depends on: 763300 778565 727560 728866 762028
Blocks: 662055 721821
  Show dependency treegraph
 
Reported: 2012-01-29 02:47 PST by Simon Montagu :smontagu
Modified: 2013-01-10 00:59 PST (History)
4 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
An HTML file with combinations of Hebrew characters and diacritics. Each pair is supposed to look the same. (932 bytes, text/html)
2012-01-29 04:44 PST, Amir Aharoni
no flags Details
A TTF font file with a font that is good for testing Hebrew rendering. (102.52 KB, application/octet-stream)
2012-01-29 04:45 PST, Amir Aharoni
no flags Details
patch, turn on harfbuzz for hebrew on all platforms (1.03 KB, patch)
2012-02-21 02:44 PST, Jonathan Kew (:jfkthame)
smontagu: review+
Details | Diff | Review

Description Simon Montagu :smontagu 2012-01-29 02:47:34 PST
Currently harfbuzz is turned on by default for Hebrew on OSX and Android, and for Arabic on all platforms. We need to determine whether there are any issues preventing turning it on for Hebrew on all platforms.
Comment 1 Amir Aharoni 2012-01-29 04:44:12 PST
Created attachment 592487 [details]
An HTML file with combinations of Hebrew characters and diacritics. Each pair is supposed to look the same.

I am attaching a file with pairs of letters with diacritics. In each pair the characters are the same, but ordered differently. Chromium displays each pair identically. Firefox on Linux with harfbuzz enabled displays the pairs differently.
Comment 2 Amir Aharoni 2012-01-29 04:45:08 PST
Created attachment 592488 [details]
A TTF font file with a font that is good for testing Hebrew rendering.
Comment 3 Amir Aharoni 2012-01-29 04:50:25 PST
On Linux:
* if the value of gfx.font_rendering.harfbuzz.scripts is 4, then all the pairs in the file hebrew-html-harfbuzz-test-aharoni.html appear different.
* if the value of gfx.font_rendering.harfbuzz.scripts is 3, then the first three pairs appear the same and correct and the last two pairs appear different.
Comment 4 Jonathan Kew (:jfkthame) 2012-02-20 06:55:12 PST
Currently, switching to harfbuzz for Hebrew would regress the rendering of older fonts such as those on Windows XP, which rely on using the Unicode presentation form codepoints for letters with dagesh (and a few other combinations).

Filed bug 728866 to address this. Once that is resolved, I think we could seriously consider switching on harfbuzz by default for all platforms.
Comment 5 Jonathan Kew (:jfkthame) 2012-02-21 02:44:41 PST
Created attachment 599072 [details] [diff] [review]
patch, turn on harfbuzz for hebrew on all platforms

I _think_ we're at the point where it makes sense to do this; Simon?
Comment 6 Jonathan Kew (:jfkthame) 2012-02-22 02:28:59 PST
Pushed to inbound:
https://hg.mozilla.org/integration/mozilla-inbound/rev/063e67b9f910

This should give us more uniform behavior for Hebrew, where previously the results varied significantly between platforms, especially with regard to diacritic handling.

(The one exceptional case will be AAT fonts on OS X, which still go through the Core Text path.)
Comment 7 Ed Morley [:emorley] 2012-02-22 16:03:48 PST
https://hg.mozilla.org/mozilla-central/rev/063e67b9f910

Note You need to log in before you can comment on or make changes to this bug.